#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"

using namespace std;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
    vector<string> colors;
};

Input input_data(istream& inp, bool prompt)
{
    Input in;
    size_t number_count;

    if(prompt){
        cerr << "Enter number_count: ";
    }
    inp >> number_count;

    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        inp >> in.numbers[i];
    }

    if(prompt){
        cerr << "Enter bin_count: ";
    }
    inp >> in.bin_count;

    in.colors.resize(in.bin_count);
    cerr << "Enter colors: ";
    for (size_t i = 0; i < in.bin_count; i++) {
        inp >> in.colors[i];
    }
    return in;
}

int main()
{
    auto in = input_data(cin, true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins, in.colors);
    return 0;
}
