#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"


TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("empty vector") {
    double min = 0;
    double max = 0;
    find_minmax({}, min, max);
    CHECK(min == 0);
    CHECK(max == 0);
}

TEST_CASE("one element") {
    double min = 0;
    double max = 0;
    find_minmax({4}, min, max);
    CHECK(min == 4);
    CHECK(max == 4);
}

TEST_CASE("negative element") {
    double min = 0;
    double max = 0;
    find_minmax({-4, -8}, min, max);
    CHECK(min == -8);
    CHECK(max == -4);
}

TEST_CASE("equal elements") {
    double min = 0;
    double max = 0;
    find_minmax({4, 4}, min, max);
    CHECK(min == 4);
    CHECK(max == 4);
}

TEST_CASE("correct input 1") {
    CHECK(check_color("red") == "red");
}

TEST_CASE("uncorrect input 2") {
    CHECK(check_color("light red") == "black");
}

TEST_CASE("uncorrect input 2") {
    CHECK(check_color("FF0000") == "black");
}
